
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Material_issuesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const material_issues = await db.material_issues.create(
            {
                id: data.id || undefined,
        
        issue_number: data.issue_number
        ||
        null
            ,
            
        issued_at: data.issued_at
        ||
        null
            ,
            
        issue_type: data.issue_type
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await material_issues.setWork_order( data.work_order || null, {
            transaction,
        });
        
        await material_issues.setIssued_by( data.issued_by || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.material_issues.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: material_issues.id,
            },
            data.attachments,
            options,
        );
        

        return material_issues;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const material_issuesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                issue_number: item.issue_number
            ||
            null
            ,
            
                issued_at: item.issued_at
            ||
            null
            ,
            
                issue_type: item.issue_type
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const material_issues = await db.material_issues.bulkCreate(material_issuesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < material_issues.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.material_issues.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: material_issues[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return material_issues;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const material_issues = await db.material_issues.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.issue_number !== undefined) updatePayload.issue_number = data.issue_number;
        
        
        if (data.issued_at !== undefined) updatePayload.issued_at = data.issued_at;
        
        
        if (data.issue_type !== undefined) updatePayload.issue_type = data.issue_type;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await material_issues.update(updatePayload, {transaction});

        
        
        if (data.work_order !== undefined) {
            await material_issues.setWork_order(
              
              data.work_order,
              
              { transaction }
            );
        }
        
        if (data.issued_by !== undefined) {
            await material_issues.setIssued_by(
              
              data.issued_by,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.material_issues.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: material_issues.id,
            },
            data.attachments,
            options,
        );
        

        return material_issues;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const material_issues = await db.material_issues.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of material_issues) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of material_issues) {
                await record.destroy({transaction});
            }
        });


        return material_issues;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const material_issues = await db.material_issues.findByPk(id, options);

        await material_issues.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await material_issues.destroy({
            transaction
        });

        return material_issues;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const material_issues = await db.material_issues.findOne(
            { where },
            { transaction },
        );

        if (!material_issues) {
            return material_issues;
        }

        const output = material_issues.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.material_issue_lines_material_issue = await material_issues.getMaterial_issue_lines_material_issue({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.work_order = await material_issues.getWork_order({
            transaction
        });
        
        
        output.issued_by = await material_issues.getIssued_by({
            transaction
        });
        
        
        output.attachments = await material_issues.getAttachments({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.work_orders,
        as: 'work_order',
        
        where: filter.work_order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.work_order.split('|').map(term => Utils.uuid(term)) } },
            {
              work_order_number: {
                [Op.or]: filter.work_order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'issued_by',
        
        where: filter.issued_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.issued_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.issued_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.issue_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'material_issues',
                        'issue_number',
                        filter.issue_number,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'material_issues',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.issued_atRange) {
                const [start, end] = filter.issued_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    issued_at: {
                    ...where.issued_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    issued_at: {
                    ...where.issued_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.issue_type) {
                where = {
                    ...where,
                issue_type: filter.issue_type,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.material_issues.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'material_issues',
                        'issue_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.material_issues.findAll({
            attributes: [ 'id', 'issue_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['issue_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.issue_number,
        }));
    }

    
};

